#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false); 
    cin.tie(NULL);    
    int n,m,l,d;
    cin>>n>>m;
    int niz[n+1];
    int mat[n+1][2]={0};
    cin>>niz[1];
    l=niz[1];
    d=m-l;
    for(int i=2;i<=n;i++)
    {
        cin>>niz[i];
        if(niz[i]<l&&niz[i]!=0)l=niz[i];
        if(m-niz[i]<d&&niz[i]!=m)d=m-niz[i];
    }
    for(int i=1;i<=n;i++)
    {
        mat[i][0]=niz[i];
        mat[i][1]=m-niz[i];
        if(niz[i]==m||niz[i]==0)
        {
            if(l<d){
                 mat[i][0]=0;
                 mat[i][1]=m;
            }
            else
            {
                 mat[i][0]=m;
                 mat[i][1]=0;
            }
        }
    }
    int br=0,rez=0;
    for(int i=1;i<=m;i++)
    {
        for(int j=1;j<=n;j++)
        if(mat[j][0]>=i)br++;
        rez+=br*(n-br);
        br=0;
    }
    for(int i=1;i<=n;i++)
    {
        cout<<mat[i][0]<<" "<<mat[i][1];
        cout<<endl;
    }
    cout<<rez;
    return 0;
}